Solodex          PROGRAM

                 INCLUDE('Equates.CLW')
                 INCLUDE('Keycodes.CLW')
                 INCLUDE('Errors.CLW')

                 MAP
                   DisplaySolodex
                   SetLastExport
                   GetFindString
                   AboutSolodex
                   CheckError(STRING)
                 END

TitleString      STRING('Solodex - A Personal Card File')

SolodexFile      STRING(100)
Solodex          FILE,DRIVER('TOPSPEED'),PRE(SOL),CREATE,NAME(SolodexFile)
CreatedKey         KEY(SOL:CreatedDate,SOL:CreatedTime,SOL:Deleted),DUP
Record             RECORD
Deleted              BYTE                  !Record deleted flag (1 = deleted)
Created              GROUP                 !Created date and time stamp
CreatedDate            LONG                !Created date
CreatedTime            LONG                !Created time
                     END
Changed              GROUP                 !Changed data and time stamp
ChangedDate            LONG                !Changed date
ChangedTime            LONG                !Changed time
                     END
NameKey              STRING(50)            !Name and company
CompanyKey           STRING(50)            !Company and name
LastName             STRING(30)            !Last name
FirstName            STRING(20)            !First name
Company              STRING(30)            !Company affiliation
ListByCompany        BYTE                  !List by company flag (1 = list)
Phones               STRING(200)           !Phone numbers
Category             STRING(15)            !Entry category
Contents             STRING(400)           !Card contents
                   END
                 END

ChangeFile       STRING(80)
Change           FILE,DRIVER('TOPSPEED'),PRE(CHG),CREATE,NAME(ChangeFile)
CreatedKey         KEY(CHG:CreatedDate,CHG:CreatedTime,CHG:Deleted),DUP
Record             RECORD
Deleted              BYTE                  !Record deleted flag (1 = deleted)
Created              GROUP                 !Created date and time stamp
CreatedDate            LONG                !Created date
CreatedTime            LONG                !Created time
                     END
Changed              GROUP                 !Changed data and time stamp
ChangedDate            LONG                !Changed date
ChangedTime            LONG                !Changed time
                     END
NameKey              STRING(50)            !Name and company
CompanyKey           STRING(50)            !Company and name
LastName             STRING(30)            !Last name
FirstName            STRING(20)            !First name
Company              STRING(30)            !Company affiliation
ListByCompany        BYTE                  !List by company flag (1 = list)
Phones               STRING(200)           !Phone numbers
Category             STRING(15)            !Entry category
Contents             STRING(400)           !Card contents
                   END
                 END

AllQueue         QUEUE,PRE(ALL)            !Card queue for all entries
Pointer            SHORT                   !Record pointer
SortKey            STRING(40)              !Name or company key
KeyType            BYTE                    !Sort key type (1 = name  2 = company)
Category           STRING(15)              !Category for tab queue
                 END

TabQueue         QUEUE,PRE(TAB)            !Card queue for current category
Pointer            SHORT                   !Record pointer
SortKey            STRING(40)              !Name or company key
KeyType            BYTE                    !Sort key type (1 = name  2 = company)
                 END

ActQueue         &QUEUE                    !Reference to active queue
ACT:Pointer      &SHORT                    !Reference to active record pointer
ACT:SortKey      &STRING                   !Reference to active name or company key
ACT:KeyType      &BYTE                     !Reference to active sort key type

CategoryQueue    QUEUE,PRE(CAT)            !Queue of tab descriptions
Category           STRING(21)              !Tab description
                 END

Phone            STRING(20),DIM(12)        !Lines in SOL:Phones
PhoneCount       LONG                      !Number of lines in SOL:Phones
PhoneString      STRING(200)               !Working string for SOL:Phones

UndoQueue        QUEUE,PRE(Undo)           !Undo queue of file operations
Action             BYTE                    !File operation
SortKey            STRING(40)              !Current sort key
KeyType            BYTE                    !Current key type
Pointer            LONG                    !Pointer to affected record
OldPointer         LONG                    !Prior selected record
                 END
ACTION:Add         EQUATE(1)               !Undo:Action value for Add
ACTION:Duplicate   EQUATE(2)               !Undo:Action value for Duplicate
ACTION:Save        EQUATE(3)               !Undo:Action value for SaveAdd
ACTION:Delete      EQUATE(4)               !Undo:Action value for Delete

I                LONG                      !General loop index
J                LONG                      !General loop index
Cursor           SHORT                     !Cursor position
Sheet            SHORT                     !Property sheet number
Motion           BYTE                      !Rollodex icon motion counter
Interval         EQUATE(20)                !Rollodex icon motion interval
CurrentTab       SHORT                     !Field number of selected tab
CurrentText      STRING(15)                !Description of selected tab
CurrentPointer   LONG                      !Pointer to current record
CurrentSortKey   STRING(40)                !Sort key of current record
CurrentKeyType   BYTE                      !key type of current record
CurrentRecord    STRING(SIZE(SOL:Record))  !Initial value of current record
Letter           LONG                      !Starting letter of selected entry
PendingAdd       SHORT                     !Record pointer of record to be added
PendingFind      SHORT                     !Field equate number of Find tab
RecordChanged    BYTE                      !1 if an entry field has been selected
NewSortKey       STRING(40)                !Sort key of new selection
LastDate         LONG                      !Date of last file export operation
LastTime         LONG                      !Time of last file export operation
LastPointer      LONG                      !Pointer to the first record in the file
FindString       STRING(20)                !Search String for Card|Find
IgnoreCase       BYTE                      !Ignore case flag (1 = ignore 0 = don't ignore)


  CODE
  DisplaySolodex
  RETURN

DisplaySolodex PROCEDURE

Window WINDOW,AT(,,402,230),FONT('MS Sans Serif',8,,),CENTER,TIMER(20),SYSTEM,GRAY,MAX
       MENUBAR
         MENU('&File'),USE(?File)
           ITEM('&New Solodex File...'),USE(?FileNew)
           ITEM('&Open Solodex File ...'),USE(?FileOpen)
           ITEM('&Save Solodex File As ...'),USE(?FileSaveAs)
           ITEM,SEPARATOR
           ITEM('&Import Changes'),USE(?FileImport)
           ITEM('&Export Changes'),USE(?FileExport)
           ITEM('Set &Last Export Date ...'),USE(?FileLastDate)
           ITEM,SEPARATOR
           ITEM('E&xit'),USE(?FileExit)
         END
         MENU('&Card'),USE(?Card)
           ITEM('&New<9>Ctrl N'),USE(?CardNew),KEY(CtrlN)
           ITEM('Du&plicate'),USE(?CardDuplicate)
           ITEM('&Delete<9>Ctrl D'),USE(?CardDelete),KEY(CtrlD)
           ITEM('&Save'),USE(?CardSave)
           ITEM('&Undo'),USE(?CardUndo)
           ITEM('&Find'),USE(?CardFind)
         END
         MENU('&Help'),USE(?Help)
           ITEM('&How to Use Solodex ...'),STD(STD:HelpIndex)
           ITEM('&Cool Stuff in Solodex ...'),USE(?HelpCoolStuff)
           ITEM('&Search Solodex Help...'),STD(STD:HelpSearch)
           ITEM,SEPARATOR
           ITEM('&About Solodex ...'),USE(?HelpAbout)
         END
       END
       IMAGE('SOLODEX.ICO'),AT(367,26,18,18),USE(?Solodex)
       REGION,AT(367,26,18,18),USE(?Animation)
       SHEET,AT(3,3,394,211),USE(Sheet),HSCROLL
         TAB('ALL'),USE(?All)
         END
       END
       OPTION,AT(12,14,347,22),USE(Letter,?All+500)
         RADIO,AT(19,20,13,13),USE(?A),ICON('A.ICO')
         RADIO,AT(32,20,13,13),USE(?B),ICON('B.ICO')
         RADIO,AT(45,20,13,13),USE(?C),ICON('C.ICO')
         RADIO,AT(58,20,13,13),USE(?D),ICON('D.ICO')
         RADIO,AT(71,20,13,13),USE(?E),ICON('E.ICO')
         RADIO,AT(84,20,13,13),USE(?F),ICON('F.ICO')
         RADIO,AT(97,20,13,13),USE(?G),ICON('G.ICO')
         RADIO,AT(110,20,13,13),USE(?H),ICON('H.ICO')
         RADIO,AT(123,20,13,13),USE(?I),ICON('I.ICO')
         RADIO,AT(136,20,13,13),USE(?J),ICON('J.ICO')
         RADIO,AT(149,20,13,13),USE(?K),ICON('K.ICO')
         RADIO,AT(162,20,13,13),USE(?L),ICON('L.ICO')
         RADIO,AT(175,20,13,13),USE(?M),ICON('M.ICO')
         RADIO,AT(188,20,13,13),USE(?N),ICON('N.ICO')
         RADIO,AT(201,20,13,13),USE(?O),ICON('O.ICO')
         RADIO,AT(214,20,13,13),USE(?P),ICON('P.ICO')
         RADIO,AT(227,20,13,13),USE(?Q),ICON('Q.ICO')
         RADIO,AT(240,20,13,13),USE(?R),ICON('R.ICO')
         RADIO,AT(253,20,13,13),USE(?S),ICON('S.ICO')
         RADIO,AT(266,20,13,13),USE(?T),ICON('T.ICO')
         RADIO,AT(279,20,13,13),USE(?U),ICON('U.ICO')
         RADIO,AT(292,20,13,13),USE(?V),ICON('V.ICO')
         RADIO,AT(305,20,13,13),USE(?W),ICON('W.ICO')
         RADIO,AT(318,20,13,13),USE(?X),ICON('X.ICO')
         RADIO,AT(331,20,13,13),USE(?Y),ICON('Y.ICO')
         RADIO,AT(344,20,13,13),USE(?Z),ICON('Z.ICO')
       END
       BUTTON,AT(159,37,20,18),TIP('Show All Entries'),USE(?ShowAll),ICON('ALL.ICO')
       BUTTON,AT(185,37,20,18),TIP('Create New Card'),USE(?New),ICON('NEW.ICO')
       BUTTON,AT(205,37,20,18),TIP('Create Duplicate Card'),USE(?Duplicate),ICON('DUPLCATE.ICO')
       BUTTON,AT(225,37,20,18),TIP('Delete Card'),USE(?Delete),ICON('DELETE.ICO')
       BUTTON,AT(245,37,20,18),TIP('Save Card Contents'),USE(?Save),ICON('SAVE.ICO')
       BUTTON,AT(265,37,20,18),TIP('Undo Last Operation'),USE(?UnDo),ICON('UNDO.ICO')
       BUTTON,AT(291,37,20,18),TIP('Find Matching Cards'),USE(?Find),ICON('FIND.ICO')
       BUTTON,AT(317,37,20,18),TIP('Import Changes'),USE(?Import),ICON('IMPORT.ICO')
       BUTTON,AT(337,37,20,18),TIP('Export Changes'),USE(?Export),ICON('EXPORT.ICO')
       LIST,AT(9,37,145,171),FONT('MS Sans Serif',8,,FONT:bold),ALRT(InsertKey),ALRT(DeleteKey),ALRT(EnterKey), |
           ALRT(MouseLeft2),USE(?CardList),VSCROLL,FORMAT('[16607L(2)]'),FROM(ALL:SortKey)
       PANEL,AT(159,57,233,55),BEVEL(1)
       PROMPT('&Last Name:'),AT(163,66,,12),USE(?Begin)
       ENTRY(@s30),AT(204,64,90,12),USE(SOL:LastName)
       PROMPT('&First:'),AT(300,66,,12)
       ENTRY(@s20),AT(319,64,67,12),USE(SOL:FirstName)
       PROMPT('&Company:'),AT(163,81,,12)
       ENTRY(@s30),AT(204,79,90,12),USE(SOL:Company)
       CHECK('&List By Company'),AT(319,79,,12),USE(SOL:ListByCompany)
       PROMPT('Ca&tegory:'),AT(163,97,,12)
       COMBO(@s15),AT(204,94,90,12),USE(SOL:Category),VSCROLL,DROP(6),FROM(CategoryQueue)
       TEXT,AT(159,115,140,94),FONT('MS Sans Serif',8,,FONT:bold),USE(SOL:Contents)
       TEXT,AT(304,115,87,94),FONT('MS Sans Serif',8,,FONT:bold),ALRT(EnterKey),USE(SOL:Phones)
     END

  CODE
  HELP('Solodex.hlp')
  OPEN(Window)
  Window{PROP:Icon} = '~Solodex.ico'
  DISABLE(?UnDo)
  DISABLE(?CardUnDo)

  SELECT(?All)

  SolodexFile = GETINI('CurrentFile','SolodexFile','','SOLODEX.INI')

  DO OpenSolodex

  ACCEPT
    IF EVENT() = EVENT:LoseFocus
      Window{PROP:Timer} = 0
      CYCLE
    END

    IF EVENT() = EVENT:GainFocus
      Window{PROP:Timer} = Interval
      CYCLE
    END

    IF EVENT() = EVENT:Timer
      Motion += 1
      IF Motion > 5 THEN Motion = 1.
      EXECUTE Motion
        ?Solodex{PROP:Text} = '~Solodex1.ico'
        ?Solodex{PROP:Text} = '~Solodex2.ico'
        ?Solodex{PROP:Text} = '~Solodex3.ico'
        ?Solodex{PROP:Text} = '~Solodex4.ico'
        ?Solodex{PROP:Text} = '~Solodex5.ico'
      END
      DISPLAY(?Solodex)
      CYCLE
    END

    CASE FIELD()

    OF ?Animation
      IF EVENT() = EVENT:Accepted
        IF Window{PROP:Timer} <> 0
          Window{PROP:Timer} = 0
          ?Solodex{PROP:Text} = '~Solodex.ico'
        ELSE
          Window{PROP:Timer} = Interval
        END
      END

    OF ?Sheet
      IF EVENT() = EVENT:NewSelection
        IF PendingFind THEN DESTROY(PendingFind).
        CurrentTab = CHOICE(?Sheet) + ?All - 1
        IF CurrentText <> CurrentTab{PROP:Text}
          DO DeletePendingAdd
          IF CurrentTab{PROP:Text} = 'ALL'
            DISABLE(?ShowAll)
            CurrentText = 'ALL'
            ?CardList{PROP:from} = ALL:SortKey
            ActQueue &= AllQueue
            ACT:Pointer &= ALL:Pointer
            ACT:SortKey &= ALL:SortKey
            ACT:KeyType &= ALL:KeyType
          ELSE
            ENABLE(?ShowAll)
            CurrentText = CurrentTab{PROP:Text}
            ?CardList{PROP:from} = TAB:SortKey
            ActQueue &= TabQueue
            ACT:Pointer &= TAB:Pointer
            ACT:SortKey &= TAB:SortKey
            ACT:KeyType &= TAB:KeyType
            DO BuildTabQueue
            IF ~RECORDS(TabQueue)
              DO DeleteCategory
              SELECT(?All)
              CYCLE
            END
          END
          SELECT(?CardList,1)
          DO DisplaySelection
          ENABLE(?New,?Duplicate)
          ENABLE(?CardNew,?CardDuplicate)
          DISPLAY(?CardList)
        END
      END

    OF ?ShowAll
      IF EVENT() = EVENT:Accepted
        SELECT(?Sheet,1,1)
        POST(EVENT:NewSelection,?Sheet)
      END

    OF ?Letter
      IF EVENT() = EVENT:Accepted
        LOOP I = 1 TO RECORDS(AllQueue)
          GET(ActQueue,I)
          IF VAL(UPPER(SUB(ACT:SortKey,1,1))) - 64 >= Letter THEN BREAK.
        END
        SELECT(?CardList,POINTER(ActQueue))
        DO DisplaySelection
      END

    OF ?CardList
      CASE EVENT()
      OF EVENT:NewSelection
        GET(ActQueue,CHOICE(?CardList))
        NewSortKey = ACT:SortKey
        IF PendingAdd
          IF SOL:LastName OR SOL:Company
            PendingAdd = 0
          ELSE
            DO DeletePendingAdd
          END
        END
        IF RecordChanged THEN DO SaveRecord.
        DO DisplaySelection
        NewSortKey = ''

      OF EVENT:AlertKey
        CASE KEYCODE()
        OF InsertKey
          POST(EVENT:Accepted,?CardNew)
        OF EnterKey OROF MouseLeft2
          SELECT(?SOL:Contents)
        OF DeleteKey
          POST(EVENT:Accepted,?CardDelete)
        END
      END

    OF ?FileNew
      IF EVENT() = EVENT:Accepted
        IF FILEDIALOG('Create a New Solodex File',SolodexFile,'Solodex|*.sol|ALL|*.*',1)
          CLOSE(Solodex)
          CREATE(Solodex)
          CheckError('Can''t Create File')
          OPEN(Solodex)
          CheckError('Can''t Open New File')
          CLEAR(SOL:Record)
          SOL:CreatedDate = TODAY()
          SOL:CreatedTime = CLOCK()
          SOL:Changed = SOL:Created
          ADD(Solodex)
          CheckError('Can''t Add First Record')
          CLOSE(Solodex)
          DO OpenSolodex
        END
      END

    OF ?FileOpen
      IF EVENT() = EVENT:Accepted
        IF FILEDIALOG('Open a Diffferent Solodex File',SolodexFile,'Solodex|*.sol|ALL|*.*',0)
          CLOSE(Solodex)
          DO OpenSolodex
        END
      END

    OF ?FileSaveAs
      IF EVENT() = EVENT:Accepted
        IF FILEDIALOG('Save Solodex File As ...',ChangeFile,'Solodex|*.sol|ALL|*.*',1)
          CLOSE(Solodex)
          CheckError('Can''t Close Solodex')
          COPY(Solodex,ChangeFile)
          CheckError('Can''t Copy Solodex')
          Solodexfile = Changefile
          DO OpenSolodex
        END
      END

    OF ?FileImport OROF ?Import
      IF EVENT() = EVENT:Accepted
        IF FILEDIALOG('Import Solodex Changes',ChangeFile,'Solodex|*.sol|ALL|*.*',0)
          OPEN(Change)
          CheckError('Can''t Open Import File')
          SET(Change)
          NEXT(Change)
          I = 0
          LOOP
            NEXT(Change)
            IF ERRORCODE() THEN BREAK.
            IF CHG:Deleted THEN CYCLE.
            SOL:Created = CHG:Created
            SOL:Deleted = 0
            GET(Solodex,SOL:CreatedKey)
            IF ERRORCODE() = NoRecErr
              I += 1
              ADD(Solodex)
              CheckError('Can''t Add Import Record')
            ELSE
              IF CHG:ChangedDate > SOL:ChangedDate    |
              OR (CHG:ChangedDate = SOL:ChangedDate AND CHG:ChangedTime > SOL:ChangedTime)
                SOL:Record = CHG:Record
                PUT(Solodex)
                CheckError('Can''t Update Import Record')
                I += 1
              END
            END
          END
          MESSAGE('Records Read: ' & RECORDS(Change)-1 & '<13,10,13,10>' & 'Records Imported: ' & I,'Export Complete')

          CLOSE(Change)
          CLOSE(Solodex)
          DO OpenSolodex
        END
      END

    OF ?FileExport OROF ?Export
      IF EVENT() = EVENT:Accepted
        IF FILEDIALOG('Export Solodex Changes',ChangeFile,'Solodex|*.sol|ALL|*.*',1)
          CREATE(Change)
          CheckError('Can''t Create Export File')
          OPEN(Change)
          STREAM(Change)
          CLEAR(CHG:Record)
          CHG:CreatedDate = TODAY()
          CHG:CreatedTime = CLOCK()
          CHG:Changed = CHG:Created
          ADD(Change)
          I = 0
          J = 0
          SET(Solodex)
          NEXT(Solodex)
          LOOP
            NEXT(Solodex)
            IF ERRORCODE() THEN BREAK.
            IF CurrentText <> 'ALL'
              IF SOL:Category <> CurrentText THEN CYCLE.
            END
            I += 1
            IF SOL:ChangedDate < LastDate THEN CYCLE.
            IF SOL:ChangedDate = LastDate AND SOL:ChangedTime < LastTime THEN CYCLE.
            CHG:Record = SOL:Record
            ADD(Change)
            CheckError('Can''t Add Export Record')
            J += 1
          END
          CLOSE(Change)
          MESSAGE('Records Read: ' & I & '<13,10,13,10>' & 'Records Exported: ' & J,'Export Complete')
          GET(Solodex,LastPointer)
          CheckError('Can''t Get First Record')
          SOL:ChangedDate = TODAY()
          SOL:ChangedTime = CLOCK()
          PUT(Solodex)
          CheckError('Can''t Put First Record')
          LastDate = SOL:ChangedDate
          LastTime = SOL:ChangedTime
          GET(Solodex,CurrentPointer)
          DO DisplaySelection
        END
      END

    OF ?FileLastDate
      IF EVENT() = EVENT:Accepted THEN SetLastExport.

    OF ?FileExit
      BREAK

    OF ?CardNew OROF ?New
      IF EVENT() = EVENT:Accepted
        Undo:SortKey = CurrentSortKey
        Undo:KeyType = CurrentKeyType
        Undo:OldPointer = CurrentPointer
        CLEAR(SOL:Record)
        IF CurrentText <> 'ALL' THEN SOL:Category = CurrentText.
        DO AddRecord
        CurrentPointer = POINTER(Solodex)
        Undo:Action = ACTION:Add
        Undo:Pointer = CurrentPointer
        ADD(UndoQueue)
        ENABLE(?Undo)
        ENABLE(?CardUndo)
      END

    OF ?CardDuplicate OROF ?Duplicate
      IF EVENT() = EVENT:Accepted
        Undo:SortKey = CurrentSortKey
        Undo:KeyType = CurrentKeyType
        Undo:OldPointer = CurrentPointer
        SOL:LastName = ''
        SOL:FirstName = ''
        DO AddRecord
        CurrentPointer = POINTER(Solodex)
        Undo:Action = ACTION:Add
        Undo:Pointer = CurrentPointer
        ADD(UndoQueue)
        ENABLE(?Undo)
        ENABLE(?CardUndo)
      END

    OF ?CardDelete OROF ?Delete
      IF EVENT() = EVENT:Accepted
        IF PendingAdd
          DO DeletePendingAdd
        ELSE
          Undo:Action = ACTION:Delete
          Undo:Pointer = POINTER(Solodex)
          Undo:SortKey = CurrentSortKey
          Undo:KeyType = CurrentKeyType
          ADD(UndoQueue)
          DO DeleteQueue
          SOL:Deleted = 1
          PUT(Solodex)
          ENABLE(?Undo)
          ENABLE(?CardUndo)
          IF CHOICE(?CardList) = 0 THEN SELECT(?CardList,RECORDS(ActQueue)).
          DO DisplaySelection
          SELECT(?CardList)
        END
      END

    OF ?CardSave OROF ?Save
      IF EVENT() = EVENT:Accepted
        IF PendingAdd
          IF ~SOL:LastName AND (~SOL:Company OR ~SOL:ListByCompany)
            DO DeletePendingAdd
            CYCLE
          END
        END
        PendingAdd = 0
        DO SaveRecord
        RecordChanged = 0
        DO DisplaySelection
        SELECT(?CardList)
      END

    OF ?CardUndo OROF ?UnDo
      IF EVENT() = EVENT:Accepted
        GET(UnDoQueue,RECORDS(UndoQueue))
        IF ERRORCODE() THEN CYCLE.
        CASE UnDo:Action
        OF ACTION:Add OROF ACTION:Duplicate
          DO DeletePendingAdd
          GET(Solodex,Undo:OldPointer)
          IF ERRORCODE() THEN CYCLE.
          CurrentSortKey = Undo:SortKey
          CurrentKeyType = Undo:KeyType
          DO SelectCurrentEntry
          DO DisplaySelection
        OF ACTION:Save
          GET(Solodex,Undo:Pointer)
          IF ERRORCODE() THEN CYCLE.
          SOL:Deleted = 1
          PUT(Solodex)
          CheckError('Can''t Put Undo Save Record')
          DO DeleteQueue
          GET(Solodex,Undo:OldPointer)
          CheckError('Can''t Get Undo Old Record')
          SOL:Deleted = 0
          PUT(Solodex)
          CurrentPointer = Undo:OldPointer
          DO InsertQueue
          DO InsertCategory
          IF CurrentText <> 'ALL'
            DO BuildTabQueue
          END
          CurrentSortKey = Undo:SortKey
          CurrentKeyType = Undo:KeyType
          DO SelectCurrentEntry
          DO DisplaySelection
        OF ACTION:Delete
          GET(Solodex,Undo:Pointer)
          IF ERRORCODE() THEN CYCLE.
          SOL:Deleted = 0
          PUT(Solodex)
          DO InsertQueue
          DO InsertCategory
          IF CurrentText <> 'ALL'
            DO BuildTabQueue
          END
          CurrentSortKey = Undo:SortKey
          CurrentKeyType = Undo:KeyType
          DO SelectCurrentEntry
          DO DisplaySelection
        END
        DELETE(UndoQueue)
        IF ~RECORDS(UndoQueue)
          DISABLE(?Undo)
          DISABLE(?CardUndo)
        END
        SELECT(?CardList)
      END

   OF ?CardFind OROF ?Find
     IF EVENT() = EVENT:Accepted
       GetFindString
       IF FindString
         IF IgnoreCase THEN FindString = UPPER(FindString).
         CLEAR(TabQueue)
         FREE(TabQueue)
         SET(Solodex)
         NEXT(Solodex)
         LOOP
           NEXT(Solodex)
           IF ERRORCODE() THEN BREAK.
           IF SOL:Deleted THEN CYCLE.
           IF ~SOL:NameKey AND ~SOL:CompanyKey THEN CYCLE.
           IF IgnoreCase
             CHG:Record = UPPER(SOL:Record)
           ELSE
             CHG:Record = SOL:Record
           END
           IF INSTRING(CLIP(FindString),CHG:Record,1)
             TAB:Pointer = POINTER(Solodex)
             TAB:SortKey = SOL:NameKey
             TAB:KeyType = 1
             IF TAB:SortKey = ''
               TAB:SortKey = SOL:CompanyKey
               TAB:KeyType = 2
             END
             ADD(TabQueue,+TAB:SortKey)
           END
         END
         IF RECORDS(TabQueue) = 0
           MESSAGE('No Matching Cards Were Found','Find Matching Card Entries')
           IF PendingFind
             DESTROY(PendingFind)
             POST(EVENT:NewSelection,?Sheet)
           END
         ELSE
           CAT:Category = 'Has "' & CLIP(FindString) & '"'
           J = ?All + RECORDS(CategoryQueue) + 1
           CREATE(J,CREATE:tab,?Sheet)
           J{PROP:Text} = CAT:Category
           UNHIDE(J)
           SELECT(?Sheet,J-?ALL+1,1)
           CurrentTab = J
           PendingFind = CurrentTab
           CurrentText = CurrentTab{PROP:Text}
           ?CardList{PROP:from} = TAB:SortKey
           ActQueue &= TabQueue
           ACT:Pointer &= TAB:Pointer
           ACT:SortKey &= TAB:SortKey
           ACT:KeyType &= TAB:KeyType
           SELECT(?CardList,1)
           DO DisplaySelection
         END
       END
     END

    OF ?HelpCoolStuff
      HELP(,'~CoolStuff')

    OF ?HelpAbout
      AboutSolodex

    OF ?SOL:LastName TO ?SOL:ListByCompany
      IF EVENT() = EVENT:Selected
        ENABLE(?Save)
        ENABLE(?CardSave)
        RecordChanged = 1
      END

    OF ?SOL:Category
      IF EVENT() = EVENT:Selected
        ENABLE(?Save)
        ENABLE(?CardSave)
        RecordChanged = 1
      END

    OF ?SOL:Contents
      IF EVENT() = EVENT:Selected
        ENABLE(?Save)
        ENABLE(?CardSave)
        RecordChanged = 1
        IF SOL:Contents = ''
          IF SOL:LastName AND SOL:FirstName
            SOL:Contents = 'Mr. ' & CLIP(SOL:FirstName) & ' ' & SOL:LastName
          ELSIF SOL:LastName AND ~SOL:FirstName
            SOL:Contents = SOL:LastName
          ELSE
            SOL:Contents = SOL:Company
          END
          DISPLAY(?SOL:Contents)
          ?SOL:Contents{PROP:SelStart} = 1
          ?SOL:Contents{PROP:SelEnd} = LEN(CLIP(SOL:Contents))
        END
      END

    OF ?SOL:Phones
      CASE EVENT()
      OF EVENT:Selected
        ENABLE(?Save)
        ENABLE(?CardSave)
        RecordChanged = 1
        DO SplitPhones
        DO ClipPhones
        DO JoinPhones
      OF EVENT:Accepted
        DO SplitPhones
        DO FormatPhones
        DO ClipPhones
        DO JoinPhones

      OF EVENT:PreAlertKey
        DO SplitPhones
        IF PhoneCount < 11
          Cursor = ?SOL:Phones{PROP:SelStart}
          SOL:Phones = SOL:Phones[1 : Cursor-1] & SOL:Phones[Cursor : LEN(SOL:Phones)]
          UPDATE(?SOL:Phones)
          DO SplitPhones
          DO FormatPhones
          DO JoinPhones
          DISPLAY(?SOL:Phones)
          SELECT(?SOL:Phones,Cursor)
        END
        CYCLE
      END
    END
  END
  CLOSE(Solodex)
  RETURN

OpenSolodex ROUTINE
  Window{PROP:Text} = TitleString & ' (' & CLIP(SolodexFile) & ')'
  CurrentText = 'ALL'
  DISABLE(?ShowAll)
  ?CardList{PROP:from} = ALL:SortKey
  ActQueue &= AllQueue
  ACT:Pointer &= ALL:Pointer
  ACT:SortKey &= ALL:SortKey
  ACT:KeyType &= ALL:KeyType

  LOOP I = 1 TO RECORDS(CategoryQueue)
    DESTROY(?All + I)
  END
  FREE(CategoryQueue)

  OPEN(Solodex)
  IF ERRORCODE()
    POST(EVENT:Accepted,?FileOpen)
    EXIT
  END
  PUTINI('CurrentFile','SolodexFile',SolodexFile,'SOLODEX.INI')
  FREE(AllQueue)
  FREE(TabQueue)
  LOGOUT(1,Solodex)
  SET(Solodex)
  NEXT(Solodex)
  LastDate = SOL:ChangedDate
  LastTime = SOL:ChangedTime
  LastPointer = POINTER(Solodex)
  LOOP
    NEXT(Solodex)
    IF ERRORCODE() THEN BREAK.
    IF SOL:Deleted OR (SOL:LastName = '' AND SOL:FirstName = '' AND SOL:ListByCompany = 0)
      DELETE(Solodex)
      CYCLE
    END
    IF SOL:Category
      CAT:Category = SOL:Category
      GET(CategoryQueue,CAT:Category)
      IF ERRORCODE()
        ADD(CategoryQueue,+CAT:Category)
        CheckError('Can''t Add Category')
      END
    END
    DO InsertQueue
  END
  COMMIT

  LOOP I = 1 TO RECORDS(CategoryQueue)
    GET(CategoryQueue,I)
    CheckError('Can''t Get Category')
    J = ?All + I
    CREATE(J,CREATE:tab,?Sheet)
    J{PROP:Text} = CAT:Category
    UNHIDE(J)
  END

  SELECT(?CardList,1)
  DO DisplaySelection

DisplaySelection ROUTINE
  IF RECORDS(AllQueue)
    GET(ActQueue,CHOICE(?CardList))
    CheckError('Can''t Get Queue Choice')
    CurrentPointer = ACT:Pointer
    Letter = VAL(UPPER(SUB(ACT:SortKey,1,1))) - 64
    IF ~RECORDS(ActQueue)
      IF CurrentText <> 'ALL'
         DO DeleteCategory
         SELECT(?All)
       END
    END

    GET(Solodex,CurrentPointer)
    CheckError('Can''t Select Solodex')
    DISPLAY
    CurrentRecord = SOL:Record
    CurrentSortKey = ACT:SortKey
    CurrentKeyType = ACT:KeyType
    RecordChanged = 0
    DISABLE(?Save)
    DISABLE(?CardSave)
    IF PendingFind
      J = LEN(CLIP(FindString))
      IF IgnoreCase
        CHG:Record = UPPER(SOL:Record)
      ELSE
        CHG:Record = SOL:Record
      END
      I = INSTRING(CLIP(FindString),CHG:LastName,1)
      IF I THEN SELECT(?SOL:LastName,I,I+J-1).
      I = INSTRING(CLIP(FindString),CHG:FirstName,1)
      IF I THEN SELECT(?SOL:FirstName,I,I+J-1).
      I = INSTRING(CLIP(FindString),CHG:Company,1)
      IF I THEN SELECT(?SOL:Company,I,I+J-1).
      I = INSTRING(CLIP(FindString),CHG:Contents,1)
      IF I THEN SELECT(?SOL:Contents,I,I+J-1).
      I = INSTRING(CLIP(FindString),CHG:Phones,1)
      IF I THEN SELECT(?SOL:Phones,I,I+J-1).
    END
  END

BuildKeys ROUTINE
  SOL:NameKey = ''
  IF SOL:LastName OR SOL:FirstName
    SOL:NameKey = SOL:LastName
    IF SOL:FirstName THEN SOL:NameKey = CLIP(SOL:NameKey) &', ' & SOL:FirstName.
    IF SOL:Company
      SOL:NameKey = CLIP(SOL:NameKey) & ' (' & CLIP(SOL:Company) & ')'
    ELSE
      SOL:ListByCompany = 0
    END
  END
  SOL:CompanyKey = ''
  IF SOL:ListByCompany
    SOL:CompanyKey = CLIP(SOL:Company)
    IF SOL:LastName OR SOL:FirstName
      SOL:CompanyKey = CLIP(SOL:CompanyKey) & ' ('   |
                     & CLIP(LEFT(CLIP(SOL:FirstName) & ' ' & SOL:LastName)) & ')'
    END
  END

AddRecord ROUTINE
  SOL:Deleted = 1
  SOL:CreatedDate = TODAY()
  SOL:CreatedTime = CLOCK()
  SOL:Changed = SOL:Created
  ADD(Solodex)
  PendingAdd = POINTER(Solodex)
  DISABLE(?New,?Duplicate)
  DISABLE(?CardNew,?CardDuplicate)

  CLEAR(ActQueue)
  ACT:Pointer = POINTER(Solodex)
  ADD(ActQueue)
  SELECT(?CardList,RECORDS(ActQueue))
  DO DisplaySelection
  SELECT(?SOL:LastName)

SaveRecord ROUTINE
  IF SOL:Record = CurrentRecord THEN EXIT.
  LOGOUT(1,Solodex)
  DO DeleteQueue
  CHG:Record = SOL:Record
  SOL:Record = CurrentRecord
  SOL:Deleted = 1
  PUT(Solodex)
  IF ERRORCODE() THEN EXIT.
  Undo:Action = ACTION:Save
  Undo:OldPointer = POINTER(Solodex)

  SOL:Record = CHG:Record
  DO BuildKeys
  SOL:Deleted = 0
  SOL:ChangedDate = TODAY()
  SOL:ChangedTime = CLOCK()
  ADD(Solodex)
  CheckError('Can''t Add Saved Record')
  COMMIT
  DO InsertQueue
  DO InsertCategory
  IF CurrentText <> CurrentTab{PROP:Text}
    CurrentTab += 1
    SELECT(?Sheet,CurrentTab - ?All + 1)
  END
  CurrentPointer = POINTER(Solodex)
  EXECUTE CurrentKeyType
    CurrentSortKey = SOL:NameKey
    CurrentSortKey = SOL:CompanyKey
  END
  IF ~CurrentSortKey THEN CurrentSortKey = CLIP(SOL:NameKey) & CLIP(SOL:CompanyKey).
  Undo:Pointer = CurrentPointer
  ADD(UndoQueue)
  PendingAdd = 0
  IF CurrentText <> 'ALL' THEN DO BuildTabQueue.
  ENABLE(?New,?Duplicate)
  ENABLE(?CardNew,?CardDuplicate)
  ENABLE(?Undo,?CardUndo)
  DO SelectCurrentEntry

DeletePendingAdd ROUTINE
  IF PendingAdd
    LOGOUT(1,Solodex)
    GET(Solodex,PendingAdd)
    DO DeleteQueue
    DELETE(Solodex)
    COMMIT
    PendingAdd = 0
    ENABLE(?New,?Duplicate)
    ENABLE(?CardNew,?CardDuplicate)
  END

InsertQueue ROUTINE
  ALL:Category = SOL:Category
  IF SOL:NameKey
    ALL:Pointer = POINTER(Solodex)
    ALL:SortKey = SOL:NameKey
    ALL:KeyType = 1
    ADD(AllQueue,+ALL:SortKey)
    CheckError('Can''t Add Name Element')
  END
  IF SOL:CompanyKey
    ALL:Pointer = POINTER(Solodex)
    ALL:SortKey = SOL:CompanyKey
    ALL:KeyType = 2
    ADD(AllQueue,+ALL:SortKey)
    CheckError('Can''t Add Company Element')
  END

DeleteQueue ROUTINE
  J = POINTER(Solodex)
  I = 1
  LOOP
    GET(AllQueue,I)
    CheckError('Can''t Get Card Element')
    IF ALL:Pointer = J
      DELETE(AllQueue)
      CheckError('Can''t Delete Card Element')
    ELSE
      I += 1
    END
  UNTIL I > RECORDS(AllQueue)
  IF CurrentText <> 'ALL' THEN DO BuildTabQueue.

SelectCurrentEntry ROUTINE
  IF NewSortKey THEN CurrentSortKey = NewSortKey.
  LOOP I = 1 TO RECORDS(ActQueue)
    GET(ActQueue,I)
    IF Act:SortKey = CurrentSortKey
      SELECT(?CardList,I)
      BREAK
    END
  END

InsertCategory ROUTINE
  IF SOL:Category
    CAT:Category = SOL:Category
    GET(CategoryQueue,CAT:Category)
    IF ERRORCODE()
      ADD(CategoryQueue,CAT:Category)
      CheckError('Can''t Add Category')
      J = ?All + RECORDS(CategoryQueue)
      CREATE(J,CREATE:tab,?Sheet)
      UNHIDE(J)
      DO RenameCategories
    END
  END

DeleteCategory ROUTINE
  GET(CategoryQueue,CurrentTab - ?All)
  CheckError('Can''t Get Sheet Choice')
  DELETE(CategoryQueue)
  DESTROY(?All + RECORDS(CategoryQueue) + 1)
  DO RenameCategories

RenameCategories ROUTINE
  LOOP I = 1 TO RECORDS(CategoryQueue)
    GET(CategoryQueue,I)
    J = ?All + I
    J{PROP:Text} = CAT:Category
  END

BuildTabQueue ROUTINE
  FREE(TabQueue)
  LOOP I = 1 TO RECORDS(AllQueue)
    GET(AllQueue,I)
    IF ALL:Category = CurrentText
      TabQueue = AllQueue
      ADD(TabQueue)
    END
  END
  IF ~RECORDS(TabQueue)
    SELECT(?ALL)
    POST(EVENT:NewSelection,?Sheet)
  END

SplitPhones ROUTINE
  PhoneString = SOL:Phones
  CLEAR(Phone)
  LOOP I = 1 TO 10
    J = INSTRING('<13,10>',PhoneString,1,1)
    IF J = 0 THEN BREAK.
    IF J > 1
      Phone[I] = LEFT(PhoneString[1 : J-1])
    END
    PhoneString = PhoneString[J+2 : LEN(PhoneString)]
  END
  IF LEN(PhoneString) THEN Phone[I] = PhoneString.
  PhoneCount = I

FormatPhones ROUTINE
  LOOP I = 1 TO PhoneCount
    IF NUMERIC(Phone[I])
      CASE LEN(CLIP(Phone[I]))
      OF 7
        Phone[I] = FORMAT(Phone[I],@P###-####P)
        Cursor += 1
      OF 10
        Phone[I] = FORMAT(Phone[I],@P(###) ###-####P)
        Cursor += 4
      OF 11
        Phone[I] = FORMAT(Phone[I],@P# (###) ###-####P)
        Cursor += 5
      END
    END
  END

ClipPhones ROUTINE
  LOOP PhoneCount = PhoneCount TO 1 BY -1
    IF Phone[PhoneCount] THEN BREAK.
  END

JoinPhones ROUTINE
  SOL:Phones = Phone[1]
  LOOP I = 2 TO PhoneCount
    SOL:Phones = CLIP(SOL:Phones) & '<13,10>' & CLIP(Phone[I])
  END

SetLastExport PROCEDURE

Export WINDOW('Set Last Export Date and Time'),AT(,,202,72),FONT('MS Sans Serif',8,,),CENTER,SYSTEM,GRAY,MASK,MODAL
         STRING('Records added after this date and time will be exported.'),AT(13,10)
         PROMPT('&Date:'),AT(37,24,,12)
         ENTRY(@d1),AT(63,24,,12),USE(LastDate)
         PROMPT('&Time:'),AT(115,24,,12)
         ENTRY(@t1),AT(137,24,,12),USE(LastTime)
         BUTTON('&OK'),AT(48,48,40,14),USE(?OK),DEFAULT
         BUTTON('&Cancel'),AT(114,48,40,14),USE(?Cancel)
       END

  CODE
  OPEN(Export)
  ACCEPT
    IF ACCEPTED() = ?OK
      GET(Solodex,LastPointer)
      SOL:ChangedDate = LastDate
      SOL:ChangedTime = LastTime
      PUT(Solodex)
      BREAK
    END
    IF ACCEPTED() = ?Cancel
      GET(Solodex,LastPointer)
      LastDate = SOL:ChangedDate
      LastTime = SOL:ChangedTime
      BREAK
    END
  END
  CLOSE(Export)

GetFindString PROCEDURE

Find WINDOW('Find Matching Card Entries'),AT(,,202,72),FONT('MS Sans Serif',8,,),CENTER,SYSTEM,GRAY,MODAL
       PROMPT('&Find what:'),AT(7,14)
       ENTRY(@s20),AT(47,12,129,12),USE(FindString)
       CHECK('&Ignore Upper/Lower Case'),AT(47,33),USE(IgnoreCase)
       BUTTON('&OK'),AT(47,51,40,14),USE(?OK),DEFAULT
       BUTTON('&Cancel'),AT(119,51,40,14),USE(?Cancel)
     END

  CODE
  OPEN(Find)
  ACCEPT
    IF ACCEPTED() = ?OK THEN BREAK.
    IF ACCEPTED() = ?Cancel
      FindString = ''
      BREAK
    END
  END
  CLOSE(Find)

AboutSolodex PROCEDURE

About WINDOW('About Solodex'),AT(,,244,137),FONT('MS Sans Serif',8,,FONT:regular),CENTER,SYSTEM,GRAY,MODAL
        STRING('Solodex is an example program developed with:'),AT(47,5)
        STRING('Clarion for Windows, Version 2.0'),AT(47,15),FONT('MS Sans Serif',10,00H,FONT:bold)
        STRING('Solodex is available in source and may be distributed'),AT(40,35)
        STRING('without restriction. For more information contact:'),AT(48,44)
        PANEL,AT(14,31,217,75),BEVEL(-2)
        STRING('TopSpeed Corporation'),AT(23,58),FONT('MS Sans Serif',8,00H,FONT:bold)
        STRING('(954) 785-5444'),AT(163,58),FONT('MS Sans Serif',8,00H,FONT:bold)
        STRING('150 East Sample Road'),AT(23,67),FONT('MS Sans Serif',8,00H,FONT:bold)
        STRING('(800) 354-5444'),AT(163,67),FONT('MS Sans Serif',8,00H,FONT:bold)
        STRING('Pompano Beach, FL 33064'),AT(23,76),FONT('MS Sans Serif',8,00H,FONT:bold)
        STRING('FAX:  (954) 946-1650'),AT(140,76),FONT('MS Sans Serif',8,00H,FONT:bold)
        STRING('Internet: http://www.topspeed.com'),AT(56,90),FONT('MS Sans Serif',8,00H,FONT:bold)
        BUTTON('OK'),AT(53,114),USE(?OK)
        IMAGE('C:\CW20\IMAGES\TOPSPEED.BMP'),AT(119,108)
      END
 CODE
 OPEN(ABOUT)
 ACCEPT
   IF ACCEPTED() = ?OK THEN BREAK.
 END
 RETURN

CheckError PROCEDURE(Caption)
  CODE
  IF ERRORCODE()
    MESSAGE(' {10}' & ERROR(),Caption,ICON:Exclamation,BUTTON:OK)
  END

